<?php
/**
 * Plugin Name: FreePay.ir ::: WooCommerce
 * Description: درگاه پرداخت آنلاین اینترنتی FreePay
 * Plugin URI: http://freepay.ir
 * Author: فری پی
 * Author URI: http://freepay.ir
 * Version: 1.0
**/

add_action('plugins_loaded', 'woocommerce_freepay_init', 0);

function woocommerce_freepay_init(){

/*
 *
 * FreePay Class;
 *
*/
class freepaySys
{
	public $gateway_url = "http://freepay.ir/payment/";
	//public function __construct () {}
	public function paymentRequest ($parameters)
	{
		if(!is_array($parameters)) die('$parameters is not an array');
		$ch=curl_init();
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_URL, $this->gateway_url.'request');
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_HEADER,0);
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 5);
		curl_setopt($ch, CURLOPT_TIMEOUT, 60);
		curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($parameters));
		$res = curl_exec($ch);
		return json_decode($res);
	}
	public function paymentVerify ($parameters)
	{
		$ch=curl_init();
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_URL, $this->gateway_url.'verify');
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_HEADER,0);
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 5);
		curl_setopt($ch, CURLOPT_TIMEOUT, 60);
		curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($parameters));
		$res = curl_exec($ch);
		return json_decode($res);
	}
}

/*
 *
 * FreePay Gateway;
 *
*/
	if ( !class_exists( 'WC_Payment_Gateway' )) return;
	if(isset($_GET['msg'])){
		add_action('the_content', 'showMessagefreepay');
	}
	
	function showMessagefreepay($content){
		return '<div class="box '.htmlentities($_GET['type']).'-box">'.base64_decode($_GET['msg']).'</div>'.$content;
	}

	class WC_freepay extends WC_Payment_Gateway{
		protected $msg = array();
	
		public function __construct(){
			$this->id = 'freepay';
			$this->method_title = __('درگاه پرداخت اینترنتی فری پی', 'freepay');
			$this->has_fields = false;
			$this->init_form_fields();
			$this->init_settings();
			$this->title = $this->settings['title'];
			$this->api = $this->settings['api'];
			$this->vahed = $this->settings['vahed'];
			$this->redirect_page_id = $this->settings['redirect_page_id'];
			$this->msg['message'] = "";
			$this->msg['class'] = "";
			add_action( 'woocommerce_api_wc_freepay', array( $this, 'check_freepay_response' ));
			add_action('valid-freepay-request', array($this, 'successful_request'));		
			if ( version_compare( WOOCOMMERCE_VERSION, '2.0.0', '>=' )){
				add_action( 'woocommerce_update_options_payment_gateways_' . $this->id, array( $this, 'process_admin_options' ));
			} 
			else{
				add_action( 'woocommerce_update_options_payment_gateways', array( $this, 'process_admin_options' ));
			}
			add_action('woocommerce_receipt_freepay', array($this, 'receipt_page'));
		}
		
/*
 *
 * FreePay Form-Fields;
 *
*/	
		function init_form_fields(){
			$this->form_fields = array(
					'enabled' => array(
							'title' => __('فعال سازی/غیر فعال سازی', 'freepay'),
							'type' => 'checkbox',
							'label' => __('فعال کردن درگاه پرداخت اینترنتی فری پی', 'freepay'),
							'default' => 'yes'),
					'title' => array(
							'title' => __('عنوان:', 'freepay'),
							'type'=> 'text',
							'description' => __('عنوانی که کاربر مشاهده خواهد کرد', 'freepay'),
							'default' => __('فری پی', 'freepay')),
					'api' => array(
							'title' => __('اپی', 'freepay'),
							'type' => 'text',
							'description' => __('اپی سایت دریافت شده از فری پی', 'freepay')),
					'vahed' => array(
							'title' => __('واحد پولی'),
							'type' => 'select',
							'options' => array(
									'rial' => 'ریال',
									'toman' => 'تومان'),
							'description' => "نیازمند افزونه ریال و تومان هست"),
					'redirect_page_id' => array(
							'title' => __('صفحه بازگشت'),
							'type' => 'select',
							'options' => $this->get_pages(''),
							'description' => "ادرس بازگشت بعد از پرداخت"
					)
			);
		}
			
/*
 *
 * FreePay Admin Options;
 *
*/
		public function admin_options(){
			echo '<h3>'.__('فری پی', 'freepay').'</h3>';
			echo '<p>'.__('فری پی').'</p>';
			echo '<table class="form-table">';
			$this->generate_settings_html();
			echo '</table>';
		}
		
		function payment_fields(){
		}
		
		function receipt_page($order){
			echo '<p>'.__('در حال اتصال به درگاه بانکی ...', 'freepay').'</p>';
			echo $this->generate_freepay_form($order);
		}
		
		function process_payment($order_id){
			$order = new WC_Order($order_id);
			return array('result' => 'success', 'redirect' => $order->get_checkout_payment_url( true )); 
		}
		
/*
 *
 * FreePay Responses from the Bank;
 *
*/
		function check_freepay_response(){
			global $woocommerce;
			$order_id = $woocommerce->session->zegersot;
			$order = new WC_Order($order_id);
			if($order_id != ''){
				if($order->status !='completed'){
					$api = $this->api;
					$authority = trim($_GET['auth']);
	                $parameters = array(
		                'api' => $api,
		                'authority' => (int) $_GET['authority']
	                );
	                $res = freepaySys::paymentVerify($parameters);
					if($res->status == 1 AND $res->message == 'ok' AND $woocommerce->session->zegersot_id==$_GET['authority']){
						$this->msg['message'] = 'پرداخت شما با موفقیت انجام شد<br/>کد پیگیری: ' . $_GET['authority'];
						$this->msg['class'] = 'success';
						$order->payment_complete();
	                    $order->add_order_note('پرداخت انجام شد<br/>کد پیگیری: ' . $_GET['authority'] . ' AND '. $_GET['authority'] );
	                    $order->add_order_note($this->msg['message']);
	                    $woocommerce->cart->empty_cart();
					}
					else{
						$this->msg['class'] = 'error';
	        			$this->msg['message'] = $res->message;
					}
				}
				else{
					$this->msg['class'] = 'error';
	        		$this->msg['message'] = "قبلا اين سفارش به ثبت رسيده يا صفارشي موجود نيست!";
				}
			}
			$redirect_url = ($this->redirect_page_id=="" || $this->redirect_page_id==0)?get_site_url() . "/":get_permalink($this->redirect_page_id);
			$redirect_url = add_query_arg( array('msg'=> base64_encode($this->msg['message']), 'type'=>$this->msg['class']), $redirect_url );
			wp_redirect( $redirect_url );
			exit();
		}
		
		function showMessage($content){
			return '<div class="box '.$this->msg['class'].'-box">'.$this->msg['message'].'</div>'.$content;
		}
		
/*
 *
 * FreePay Form Generation;
 *
*/
		public function generate_freepay_form($order_id){
			global $woocommerce;
			$order = new WC_Order($order_id);
			$redirect_url = ($this->redirect_page_id=="" || $this->redirect_page_id==0)?get_site_url() . "/":get_permalink($this->redirect_page_id);
			$redirect_url = add_query_arg( 'wc-api', get_class( $this ), $redirect_url );
			unset( $woocommerce->session->zegersot );
			unset( $woocommerce->session->zegersot_id );
			$woocommerce->session->zegersot = $order_id;
			$amount = $order->order_total;
			if($this->vahed=='toman')
				$amount = $amount * 10;
			$api = $this->api;
			$amount = $amount;
			$callback = $redirect_url;
	        $parameters = array(
		        'api' => $this->api,
		        'amount' => (int) $amount,
		        'callback' => $callback,
		        'host' => $_SERVER['SERVER_NAME']
	        );
			$res = freepaySys::paymentRequest($parameters);
			if($res->type=='success'){ 
				$woocommerce->session->zegersot_id = $res->auth;
				$authority = $res->auth;
				header("Location: ".freepaySys::gateway_url."gateway:".$res->auth);
			}
			else 
				echo $res->message;
		}
	        
		function get_pages($title = false, $indent = true){
			$wp_pages = get_pages('sort_column=menu_order');
			$page_list = array();
			if ($title) $page_list[] = $title;
				foreach ($wp_pages as $page){
					$prefix = '';
					if ($indent){
						$has_parent = $page->post_parent;
						while($has_parent){
							$prefix .=  ' - ';
							$next_page = get_page($has_parent);
							$has_parent = $next_page->post_parent;
						}
					}
					$page_list[$page->ID] = $prefix . $page->post_title;
				}
				return $page_list;
		}
	}
	
	function woocommerce_add_freepay_gateway($methods){
		$methods[] = 'WC_freepay';
			return $methods;
	}
	
	add_filter('woocommerce_payment_gateways', 'woocommerce_add_freepay_gateway' );
}
?>
